﻿var M = {};

(function () {
    M.location = function (url) {
        if (url && url !='#') {
            window.location.href = url;
        }
    }

    M.goBack = function () {
        window.history.back();
    }
})();


(function ($, M) {

	M.Page = {};

	var $aBack = $("header .header-toolbar-left");
	var $title = $("header h1");
	var queue = [];

	M.Page.back = function () {
	    if (queue.length <2) {
	        return false;
	    }
	    queue.pop();
	    var options = queue[queue.length - 1];
	    load(options.title, options.html, options.url, options.click);
	};

	function load(title, html, url, click) {
	    

	    $title.html(title);

	    $aBack.html(html);

	    $aBack.off("click").on("click", function () {
	        if (click) {
	            click();
	        }
	        if (url) {
	            M.location(url);
	        }
	        M.Page.back();
	        return false;
	    });
	}

	M.Page.set = function (options) {
	    var backHtml = '<span class="header-btn header-btn-back"></span>';

	    queue.push({
	        title: options.title,
	        click: options.click,
	        url: options.url,
            html: backHtml
	    });

	    load(options.title, backHtml, options.url, options.click);
	};

	$(function () {
	    $aBack = $("header .header-toolbar-left");
	    $title = $("header h1");

	    queue.push({
	        title: $title.html(),
	        click: null,
	        url: $aBack.attr("href"),
	        html: $aBack.html()
	    });
	});

})(jQuery, M);


(function () {

    var queue = [];

	M.Dialog = function (options) {
	    options = $.extend(true, {
	        id: "selecthangye",
			title: "",
			content: null,
			onOk: null
		}, options, true);

		var that = this;

		var $dialog = createHtml();
		loadContent($dialog, options);


		this.back = function () {
			M.Page.setBack({
				click: function () {
					that.hide();
				}
			})
		};

		this.close = function (code, result) {
		    this.hide();
		    M.Page.back();
		};

		this.ok = function (result) {
		    if (options.onOk) {
		        options.onOk.call(that, result);
		    }
		    this.close("ok", result);
		}

		this.hide = function () {
		    $dialog.velocity({
		        left: "100%"
		    }, function () {
		        $(this).hide();
		    });
		};

		this.show = function () {
		    showContent($dialog, options);
			$dialog.show().velocity({
				left: "0%"
			});
			M.Page.set({
			    title: options.title,
			    click: function () {
			        that.close();
			    }
			});
		}
	}

	M.Dialog.get = function (id) {
	    var dialog;

	    $.each(queue, function (i, item) {
	        if (item.id == id) {
	            dialog = item.dialog;
	            return false;
	        }
	    });

	    return dialog;
	}

	M.Dialog.create = function (options) {
	    var id = options.id;
	    if (!id) {
	        throw Error("id 不能为空");
	        return false;
	    }

	    var dialog = M.Dialog.get(id);

	    if (dialog) {
	        return dialog;
	    }

	    dialog = new M.Dialog(options);

	    queue.push({
	        id: id,
	        dialog: dialog
	    });

		return dialog;
	};


	function createHtml() {

		var $dialog = $("#dialog");

		if ($dialog.length == 0) {
			var html = '<div id="dialog" class="dialog">';
			$dialog = $(html);
			$("body").append($dialog);
            /*
			setTimeout(function () {
			    new IScroll('#dialog', { mouseWheel: true });
			}, 200);
            */
		}

		return $dialog;
	};

	function showContent($dialog, options) {
	    var id = "dialog-" + options.id;
	    var $content = $('#' + id);
	    $content.show().siblings().hide();
	}

	function loadContent($dialog, options) {
	    var id = "dialog-" + options.id;
	    var $content = $('#' + id);
	    if ($content.length == 0) {
	        $content = $('<div id="' + id + '"></div>');
	        $content.html(options.content);
	        $dialog.find(">div").hide();
	        $dialog.append($content);
	    }
	    else {
	        $content.show().siblings().hide();
	    }
	}

})(jQuery, M);

